<template>
  <div class="profile-photo">
    <h5 class="mb-5">{{ type }} photo</h5>
    <input
      ref="fileInput"
      type="file"
      accept="image/*"
      style="display: none;"
      @change="onFilePicked"
    />
    <div class="no-profile-image">
      <v-icon
        v-if="!imageUrl || (imageUrl && !imageUrl.length)"
        size="180"
        class="account"
      >
        mdi-account
      </v-icon>
      <v-img
        v-if="imageUrl && imageUrl.length"
        class="image"
        :src="imageUrl"
        aspect-ratio="1"
        max-width="180"
      />
      <v-btn
        class="upload-image"
        fab
        dark
        small
        color="primary"
        @click="onPickFile"
      >
        <v-icon dark>
          mdi-pencil
        </v-icon>
      </v-btn>
    </div>

    <v-row v-if="image" justify="center" class="mt-4">
      <v-btn :loading="loading" small color="primary" @click="upload">
        Upload image
      </v-btn>
    </v-row>
    <v-snackbar
      v-model="imageSuccessMessage"
      color="primary"
      :timeout="6000"
      top
    >
      You uploaded your image successfully.

      <template>
        <v-btn dark text @click="imageSuccessMessage = false">
          X
        </v-btn>
      </template>
    </v-snackbar>
  </div>
</template>

<script>
import { mapState } from 'vuex'
import EventBus from '@/event-bus'

export default {
  name: 'ImageUpload',
  props: {
    initialImage: {
      type: String,
      default: '',
      required: false
    },
    path: {
      type: String,
      default: 'facilitators',
      required: false
    },
    type: {
      type: String,
      default: 'profile',
      required: false
    },
    circleId: {
      type: String,
      default: null,
      required: false
    }
  },
  data() {
    return {
      imageUrl: this.initialImage,
      image: null,
      loading: false,
      imageSuccessMessage: false
    }
  },
  computed: {
    ...mapState('authentication', ['user']),
    ...mapState('app', ['stateImageUrl'])
  },
  watch: {
    initialImage: {
      handler(image) {
        this.imageUrl = image
      }
    },
    stateImageUrl: {
      handler(url) {
        if (url) {
          EventBus.$emit('setCircleImageUrl', url)
        }
      }
    }
  },
  methods: {
    onPickFile() {
      this.$refs.fileInput.click()
    },
    onFilePicked(event) {
      const { files } = event.target
      const filename = files[0].name
      if (filename.lastIndexOf('.') <= 0) return

      const fileReader = new FileReader()
      fileReader.addEventListener('load', () => {
        this.imageUrl = fileReader.result
      })
      fileReader.readAsDataURL(files[0])
      this.image = files[0]
    },
    upload() {
      if (this.image) {
        this.loading = true
        const data = {
          image: this.image,
          type: this.type,
          uid: this.user.uid,
          profileId: this.user.uid,
          path: this.path
        }
        if (this.type === 'circle') {
          data.circleId = this.circleId
        }
        this.$store
          .dispatch('app/uploadImage', data)
          .then(() => {
            this.imageSuccessMessage = true
            this.loading = false
          })
          .catch(() => (this.loading = false))
      }
    }
  }
}
</script>

<style lang="scss">
.profile-photo {
  margin-bottom: 1rem;
  display: inline-block;
  .no-profile-image {
    background: #e8e8e8;
    border: 1px solid #333;
    border-radius: 100%;
    width: fit-content;
    position: relative;
    .account {
      color: white;
    }
    .upload-image {
      position: absolute;
      right: 0;
      bottom: 0;
    }
    .image {
      width: 180px;
      border-radius: 100%;
    }
  }
}
</style>
